/*
 * UDP send/receive tool for packet loss detection.
 * Copyright 2007 by Toru Takahashi.
 */
package sender;

import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JComboBox;
import javax.swing.JButton;
import javax.swing.GroupLayout;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import java.util.Vector;
import javax.swing.DefaultComboBoxModel;
import java.awt.event.WindowListener;

/**
 * UdpSendervOɂāAModel-View-Presenterp^[ۂ
 * ViewNXB
 * $Id$
 */
public class UdpSendFrame extends JFrame implements UdpSendView {

    public UdpSendFrame() {
        super("UDP Send Program");
        setDefaultCloseOperation(EXIT_ON_CLOSE);

        JPanel panel = new JPanel();
        GroupLayout layout = new GroupLayout(panel);
        panel.setLayout(layout);
        layout.setAutoCreateGaps(true);
        layout.setAutoCreateContainerGaps(true);

        addressLabel = new JLabel("MAhXF");
        addressComboBox = new JComboBox();
        addressComboBox.setEditable(true);
        portLabel = new JLabel("M|[gF");
        portComboBox = new JComboBox();
        portComboBox.setEditable(true);
        sizeLabel = new JLabel("Mf[^TCYF");
        sizeComboBox = new JComboBox();
        sizeComboBox.setEditable(true);
        intervalLabel = new JLabel("MԊu[ms]F");
        intervalComboBox = new JComboBox();
        intervalComboBox.setEditable(true);
        countLabel = new JLabel("M񐔁F");
        countComboBox = new JComboBox();
        countComboBox.setEditable(true);
        sendButton = new JButton(SEND_BUTTON_TEXT_ENABLED);

        // ́A4̏
        GroupLayout.SequentialGroup hGroup = layout.createSequentialGroup();
        hGroup.addGroup(
            layout.createParallelGroup()
            .addComponent(addressLabel)
            .addComponent(sizeLabel)
            .addComponent(sendButton)
        );
        hGroup.addGroup(
            layout.createParallelGroup()
            .addComponent(addressComboBox)
            .addComponent(sizeComboBox)
        );
        hGroup.addGroup(
            layout.createParallelGroup()
            .addComponent(portLabel)
            .addComponent(intervalLabel)
            .addComponent(countLabel)
        );
        hGroup.addGroup(
            layout.createParallelGroup()
            .addComponent(portComboBox)
            .addComponent(intervalComboBox)
            .addComponent(countComboBox)
        );
        layout.setHorizontalGroup(hGroup);

        // ́A4̏
        GroupLayout.SequentialGroup vGroup = layout.createSequentialGroup();
        vGroup.addGroup(
            layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
            .addComponent(addressLabel)
            .addComponent(addressComboBox)
            .addComponent(portLabel)
            .addComponent(portComboBox)
        );
        vGroup.addGroup(
            layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
            .addComponent(sizeLabel)
            .addComponent(sizeComboBox)
            .addComponent(intervalLabel)
            .addComponent(intervalComboBox)
        );
        vGroup.addGroup(
            layout.createParallelGroup(GroupLayout.Alignment.BASELINE)
            .addComponent(countLabel)
            .addComponent(countComboBox)
        );
        vGroup.addComponent(sendButton);

        layout.setVerticalGroup(vGroup);

        add(panel);
    }

    @Override public void setAddressList(Vector<String> aList) {
        addressComboBox.setModel(new DefaultComboBoxModel(aList));
    }

    @Override public void setSizeList(Vector<Integer> aList) {
        sizeComboBox.setModel(new DefaultComboBoxModel(aList));
    }

    @Override public void setPortList(Vector<Integer> aList) {
        portComboBox.setModel(new DefaultComboBoxModel(aList));
    }

    @Override public void setIntervalList(Vector<Integer> aList) {
        intervalComboBox.setModel(new DefaultComboBoxModel(aList));
    }

    @Override public void setCountList(Vector<Integer> aList) {
        countComboBox.setModel(new DefaultComboBoxModel(aList));
    }

    @Override public String getAddress() {
        String item = (String)addressComboBox.getSelectedItem();
        return item;
    }

    @Override public int getDataSize() {
        Integer item = (Integer)sizeComboBox.getSelectedItem();
        return item;
    }

    @Override public int getPort() {
        Integer item = (Integer)portComboBox.getSelectedItem();
        return item;
    }

    @Override public int getInterval() {
        Integer item = (Integer)intervalComboBox.getSelectedItem();
        return item;
    }

    @Override public int getCount() {
        Integer item = (Integer)countComboBox.getSelectedItem();
        return item;
    }

    @Override public void addSendListener(ActionListener aListener) {
        sendButton.addActionListener(aListener);
    }
    @Override public void setSendEnabled(boolean isEnabled) {
        sendButton.setEnabled(isEnabled);
        sendButton.setText(
            isEnabled ? SEND_BUTTON_TEXT_ENABLED : SEND_BUTTON_TEXT_DISABLED
        );
    }

    @Override public void addViewListener(WindowListener aListener) {
        this.addWindowListener(aListener);
    }

    @Override public void showView() {
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    UdpSendFrame.this.pack();
                    UdpSendFrame.this.setVisible(true);
                }
            }
        );
    }

    @Override public void showError(Exception e) {
        JOptionPane.showMessageDialog(
            this, e, "O", JOptionPane.ERROR_MESSAGE
        );
    }

    @Override public void showFinished() {
        JOptionPane.showMessageDialog(
            this, "MI܂B", "M", 
            JOptionPane.INFORMATION_MESSAGE
        );
    }

    /**
     * View̃CAEgmF邽߂̒P̗pmain\bhB
     */
    public static final void main(final String[] args) {
        final JFrame view = new UdpSendFrame();
        view.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        SwingUtilities.invokeLater(new Runnable() {
                public void run() {
                    view.pack();
                    view.setVisible(true);
                }
            }
        );
    }

    private JLabel addressLabel;
    private JComboBox addressComboBox;
    private JLabel portLabel;
    private JComboBox portComboBox;
    private JLabel sizeLabel;
    private JComboBox sizeComboBox;
    private JLabel intervalLabel;
    private JComboBox intervalComboBox;
    private JLabel countLabel;
    private JComboBox countComboBox;
    private JButton sendButton;

    private static final String SEND_BUTTON_TEXT_ENABLED = "MJn";
    private static final String SEND_BUTTON_TEXT_DISABLED = "M";
}
