/*
 * UDP send/receive tool for packet loss detection.
 * Copyright 2007 by Toru Takahashi.
 */
package sender;

import java.util.Vector;
import java.util.Set;
import model.UdpModel;

/**
 * UdpSendervOɂāAModel-View-Presenterp^[ۂ
 * Model̎B
 *
 * $Id$
 */
public class UdpSendModel extends UdpModel {
    /**
     * ftHgERXgN^B
     * Preferences APIŉiꂽf[^擾tB[hɃZbgB
     */
    public UdpSendModel() {
        super(UdpSendModel.class);
        addressSet = readStringSetFromPreferences(KEY_ADDRESS, "::1");
        portSet = readIntegerSetFromPreferences(KEY_PORT, 1234);
        sizeSet = readIntegerSetFromPreferences(KEY_SIZE, 100);
        intervalSet = readIntegerSetFromPreferences(KEY_INTERVAL, 0);
        countSet = readIntegerSetFromPreferences(KEY_COUNT, 10);
    }

    /**
     * Preferences APIɃf[^ۑB
     */
    public void save() {
        putToPreferences(KEY_ADDRESS, getStringForPreferences(addressSet));
        putToPreferences(KEY_PORT, getStringForPreferences(portSet));
        putToPreferences(KEY_SIZE, getStringForPreferences(sizeSet));
        putToPreferences(KEY_INTERVAL, getStringForPreferences(intervalSet));
        putToPreferences(KEY_COUNT, getStringForPreferences(countSet));
    }

    public void addAddress(final String anAddress) {
        addressSet.add(anAddress);
    }
    public void addPort(final int aPort) {
        portSet.add(aPort);
    }
    public void addSize(final int aSize) {
        sizeSet.add(aSize);
    }
    public void addInterval(final int anInterval) {
        intervalSet.add(anInterval);
    }
    public void addCount(final int aCount) {
        countSet.add(aCount);
    }

    public Vector<String> getAddressList() {
        return new Vector<String>(addressSet);
    }
    public Vector<Integer> getPortList() {
        return new Vector<Integer>(portSet);
    }
    public Vector<Integer> getSizeList() {
        return new Vector<Integer>(sizeSet);
    }
    public Vector<Integer> getIntervalList() {
        return new Vector<Integer>(intervalSet);
    }
    public Vector<Integer> getCountList() {
        return new Vector<Integer>(countSet);
    }

    private Set<String> addressSet;
    private Set<Integer> portSet;
    private Set<Integer> sizeSet;
    private Set<Integer> intervalSet;
    private Set<Integer> countSet;

    private static final String KEY_ADDRESS = "address";
    private static final String KEY_PORT = "port";
    private static final String KEY_SIZE = "size";
    private static final String KEY_INTERVAL = "interval";
    private static final String KEY_COUNT = "count";
}
